/*		The following code was written as an example of a number
		of Series 3a specific concepts. These include:

		.	Use of the large screen
		.	Enabling grey (used in attractive screen border for
			example)
		.	Resizing the main window to take account of three
			sizes of Status Window
		.	Use of the Diamond key/list
		.	Menus with case sensitive accelerators
		.	Menus which differ according to the application 'view' (the
			view or mode being reflected in the Diamond list)
		.	Menus which remember the last selected item even between
			views
		.	Menus with grey lines

 Queries about this code should be sent to:

  CIX				: psion_c
  Other email	: psion_c@cix.compulink.co.uk
  or				: 73733.32@compuserve.com

The code is not perfect. It is for guidance only
you might love it or hate it. E & OE as they say
in the small print.

*/

	

#include <p_std.h>
#include <p_file.h>
#include <wlib.h>
#include <hwif.h>

#ifndef W_KEY_DIAMOND                 /*  Your SDK may not have this defined  */
	#define W_KEY_DIAMOND	0x0124
#endif

GLREF_D UWORD				_UseFullScreen;                /*  For uCommonInit()  */
GLREF_D UWORD			*	_MenuPositions;    /*  Points to menu pos. reminders  */
GLREF_D UWORD			*	_GreyLines;            /*  Points to underline masks  */

LOCAL_D UINT				MainWid;                       /*  ID of main window  */
LOCAL_D INT					CurrentStatusWindowExtent = W_STATUS_WINDOW_BIG;

LOCAL_D WORD				keystat;
LOCAL_D INT					gc;                       /*  ID of graphics context  */

LOCAL_D UINT				modepos = 0;            /*  Current Diamond position  */
LOCAL_D TEXT			*	modelist[] = 	{
													"Serious",
													"Silly",
													"Useless"
													};        /*  Titles of views in list  */


LOCAL_D UWORD				Menu1Pos;       /*  Remembers position in menu bar 1  */
LOCAL_D UWORD				Menu2Pos;       /*  Remembers position in menu bar 2  */

LOCAL_D UWORD				Lines[16];                  /*  Menu underline masks  */


LOCAL_D TEXT			*	cmds1[]=
    {
    "nNew",
    "oOpen",
    "mMerge",
    "aSave as",
    "kCompress",
    "iInsert text",
    "cCopy text",
    "vEvaluate",
    "pPrint",
    "yPrint setup",
	 "XExit, lose changes",
	 "xExit",
    NULL
    };                               /*  Text and accelerators of menu bar 1  */

#define FILE_ITEMS			5
#define EDIT_ITEMS			3
#define SPECIAL1_ITEMS		4

#define ITEMS_BEFORE_FILE			0
#define ITEMS_BEFORE_EDIT			FILE_ITEMS
#define ITEMS_BEFORE_SPECIAL1		(ITEMS_BEFORE_EDIT + EDIT_ITEMS)

LOCAL_D H_MENU_DATA mdata1[]=
	{
	"File", FILE_ITEMS,
	"Edit", EDIT_ITEMS,
	"Special", SPECIAL1_ITEMS,
	NULL
	};                                                 /*  Menu card 1 titles  */


	
LOCAL_D TEXT			*	cmds2[]=
    {
    "aApple",
    "bBanana",
    "cCucumber",
	 "pPotato",
	 "tTurnip",
	 "dDog",
	 "sSiamese cat",
	 "zZebra",
	 "gGnu",
	 "fFridge",
	 "oOven",
	 "mMicrowave",
	 "wWasherDryer",
	 "eEmpathy",
	 "hHolistic medicine",
	 "iInk",
	 "rRumplestiltskin",
	 "yYardbird",
    "xExit",
    NULL
    };                               /*  Text and accelerators of menu bar 2  */

#define FRUIT_ITEMS			3
#define VEGETABLE_ITEMS		2
#define ANIMAL_ITEMS			4
#define WHITE_ITEMS			4
#define SPECIAL2_ITEMS		6

#define ITEMS_BEFORE_FRUIT			0
#define ITEMS_BEFORE_VEGETABLE	FRUIT_ITEMS
#define ITEMS_BEFORE_ANIMAL		(ITEMS_BEFORE_VEGETABLE + VEGETABLE_ITEMS)
#define ITEMS_BEFORE_WHITE			(ITEMS_BEFORE_ANIMAL + ANIMAL_ITEMS)
#define ITEMS_BEFORE_SPECIAL2		(ITEMS_BEFORE_WHITE + WHITE_ITEMS)

LOCAL_D H_MENU_DATA mdata2[]=
	{
	"Fruit", FRUIT_ITEMS,
	"Vegetable", VEGETABLE_ITEMS,
	"Animal", ANIMAL_ITEMS,
	"White", WHITE_ITEMS,
	"Special", SPECIAL2_ITEMS,
	NULL
	};                                                 /*  Menu card 2 titles  */

	
GLDEF_D TEXT			**	_cmds		=	(&cmds1[0]);      /*  Points to commands  */
GLDEF_D H_MENU_DATA	*	_mdata	=	(&mdata1[0]);   /*  Points to menu cards  */


/*  Clear the entire window  -----------------------------------------------  */

LOCAL_C VOID ClearWholeWindow(VOID)
	{
	P_RECT					whole;

	whole.tl.x = whole.tl.y = 0;
	whole.br.x = 480;
	whole.br.y = 160;
	gClrRect(&whole, G_TRMODE_CLR);
	}


	 
/*  Size the main window, border it and display  ---------------------------
    Status Window according to current size  -------------------------------  */
	 
LOCAL_C VOID SizeMainWindow(VOID)
	{
	P_EXTENT					StatusExtent;
	W_WINDATA				wd;

	wInquireStatusWindow(CurrentStatusWindowExtent, &StatusExtent);
	wd.extent.tl.x		=	0;
	wd.extent.tl.y		=	0;
	wd.extent.width	=	480 - StatusExtent.width;
	wd.extent.height	=	160;
	wSetWindow(MainWid, W_WIN_EXTENT, &wd);
	ClearWholeWindow();
	wStatusWindow(CurrentStatusWindowExtent);
	gBorder2(W_BORDER_TYPE_1, W_BORD_CORNER_4|W_BORD_SHADOW_ON|W_BORD_SHADOW_D);
	}



/*  Work out the next version of the Status Window  ------------------------  */

LOCAL_C VOID ToggleStatusWindow()
	{
	CurrentStatusWindowExtent++;
	CurrentStatusWindowExtent %= 3;
	}



/*  Create a graphics context  ---------------------------------------------  */

LOCAL_C VOID CreateGC(VOID)
	{
	INT					hgc;

	hgc	=	gCreateGC0(MainWid);
	if (hgc	<	0)
		p_exit(hgc);
	}



/*  Manage the menu command selected in view 1  ----------------------------  */

LOCAL_C VOID ManageCommand1(INT index)
	{
	switch (index)
		{
		case ITEMS_BEFORE_FILE:
			wInfoMsg("New");
			break;
		case ITEMS_BEFORE_FILE + 1:
			wInfoMsg("Open");
			break;
		case ITEMS_BEFORE_FILE + 2:
			wInfoMsg("Merge");
			break;
		case ITEMS_BEFORE_FILE + 3:
			wInfoMsg("Save as");
			break;
		case ITEMS_BEFORE_FILE + 4:
			wInfoMsg("Compress");
			break;
		case ITEMS_BEFORE_EDIT:
			wInfoMsg("Insert text");
			break;
		case ITEMS_BEFORE_EDIT + 1:
			wInfoMsg("Copy text");
			break;
		case ITEMS_BEFORE_EDIT + 2:
			wInfoMsg("Evaluate");
			break;
		case ITEMS_BEFORE_SPECIAL1:
			wInfoMsg("Print");
			break;
		case ITEMS_BEFORE_SPECIAL1 + 1:
			wInfoMsg("Print setup");
			break;
		case ITEMS_BEFORE_SPECIAL1 + 2:
			p_exit(0);
		case ITEMS_BEFORE_SPECIAL1 + 3:
			p_exit(0);
		}
	}



/*  Manage the menu command selected in view 2  ----------------------------  */

LOCAL_C VOID ManageCommand2(INT index)
	{
	switch (index)
		{
		case ITEMS_BEFORE_FRUIT:
			wInfoMsg("Apple");
			break;
		case ITEMS_BEFORE_FRUIT + 1:
			wInfoMsg("Banana");
			break;
		case ITEMS_BEFORE_FRUIT + 2:
			wInfoMsg("Cucumber");
			break;
		case ITEMS_BEFORE_VEGETABLE:
			wInfoMsg("Potato");
			break;
		case ITEMS_BEFORE_VEGETABLE + 1:
			wInfoMsg("Turnip");
			break;
		case ITEMS_BEFORE_ANIMAL:
			wInfoMsg("Dog");
			break;
		case ITEMS_BEFORE_ANIMAL + 1:
			wInfoMsg("Siamese Cat");
			break;
		case ITEMS_BEFORE_ANIMAL + 2:
			wInfoMsg("Zebra");
			break;
		case ITEMS_BEFORE_ANIMAL + 3:
			wInfoMsg("Gnu");
			break;
		case ITEMS_BEFORE_WHITE:
			wInfoMsg("Fridge");
			break;
		case ITEMS_BEFORE_WHITE + 1:
			wInfoMsg("Oven");
			break;
		case ITEMS_BEFORE_WHITE + 2:
			wInfoMsg("Microwave");
			break;
		case ITEMS_BEFORE_WHITE + 3:
			wInfoMsg("WasherDryer");
			break;
		case ITEMS_BEFORE_SPECIAL2:
			wInfoMsg("Empathy");
			break;
		case ITEMS_BEFORE_SPECIAL2 + 1:
			wInfoMsg("Holistic medicine");
			break;
		case ITEMS_BEFORE_SPECIAL2 + 2:
			wInfoMsg("Ink");
			break;
		case ITEMS_BEFORE_SPECIAL2 + 3:
			wInfoMsg("Rumplestiltskin");
			break;
		case ITEMS_BEFORE_SPECIAL2 + 4:
			wInfoMsg("Yardbird");
			break;
		case ITEMS_BEFORE_SPECIAL2 + 5:
			p_exit(0);
		}
	}



/*  Look up the selected command and manage appropriately  -----------------  */

LOCAL_C VOID TryExecuteCommand(INT keycode)
	{
	if (modepos == 2)
		return;
	keycode = uLocateCommand(keycode);
	if (keycode >= 0)
		{
		if (modepos)
			ManageCommand2(keycode);
		else
			ManageCommand1(keycode);
		}
	}


	 
/*  Listen to the shell  ---------------------------------------------------  */

LOCAL_C VOID ProcessSystemCommand(VOID)
	{
	TEXT						buf[P_FNAMESIZE + 2];

	wGetCommand((UBYTE *)&buf[0]);
	if (buf[0] == 'X')
		p_exit(0);
	}


	 
/*  Do the right thing when Diamond is pressed  ----------------------------  */

LOCAL_C VOID SwitchMode(VOID)
	{
	modepos++;
	modepos %= 3;
	wsSelectList(modepos);
	if (modepos)
		{
		_cmds		=	(&cmds2[0]);
		_mdata	=	(&mdata2[0]);
		}
	else
		{
		_cmds		=	(&cmds1[0]);
		_mdata	=	(&mdata1[0]);
		}
	}	
	 
	

/*  Main loop  -------------------------------------------------------------  */

LOCAL_C VOID MainLoop(VOID)
	{
	INT						ret;
	WMSG_KEY					key;

	FOREVER
		{
		uGetKey(&key);                                /*  Wait for a key event  */
		if (key.keycode & W_EVENT_KEY)                    /*  If it's an event  */
			{
			switch (key.keycode)
				{
				case CONS_EVENT_FOREGROUND:         /*  Foreground specific code  */
					wInfoMsg("Came to foreground");
					break;
				case CONS_EVENT_COMMAND:                /*  The shell has spoken  */
					ProcessSystemCommand();                    /*  Obey the shell  */
				}
			}
		else if (key.keycode & W_SPECIAL_KEY)              /* Psion key pressed */
			TryExecuteCommand(key.keycode & (~W_SPECIAL_KEY));
		else
			{
			switch (key.keycode)
				{
				case W_KEY_MENU:                             /* Menu key pressed  */
					if (key.modifiers & W_CTRL_MODIFIER)
						{
						ToggleStatusWindow();     /*  User wants to change size of  */
						SizeMainWindow();    /*  screen and style of status window  */
						}
					else
						{
						if (modepos == 2)            /*  Tell user not to be silly  */
							{
							wInfoMsg("No menus in Mode 3");
							break;
							}
						else       /*  Underline correct options depending on view  */
							{
							p_bfil(&Lines[0], sizeof(Lines), 0);
							uAddGreyUline('y', &Lines[0]);
							if (modepos)
								{
								uAddGreyUline('h', &Lines[0]);
								_MenuPositions = &Menu1Pos;
								}
							else
								_MenuPositions = &Menu2Pos;
								
							ret = uPresentMenus();             /*  Display the menu  */
							if (ret > 0)
								TryExecuteCommand(ret);       /*  Try to please user  */
							}
						}
					break;
				case W_KEY_DIAMOND:                              /*  Change mode  */
					SwitchMode();
					break;
				}
			}
		}
	}
	
	
	
/*  Do some initialisation  ------------------------------------------------  */

LOCAL_C VOID SpecificInit(VOID)
	{
	_GreyLines = &Lines[0];                   /*  Point to underline masks OK  */

	uEnableGrey();                                            /*  Grey please  */
	MainWid	=	uFindMainWid();                            /*  Get the handle  */
	CreateGC();                                 /*  Create a graphics context  */
	SizeMainWindow();  /*  Initialise the main screen and get a status window  */
	wsSetList(3, &modelist[0], modepos);      /*  Initialise the Diamond list  */
	}



/*  Glory be to main()  ----------------------------------------------------  */

GLDEF_C VOID main(VOID)
	{
	_UseFullScreen = TRUE;           /*  Use the full extent of the 3a screen  */
	uCommonInit();                           /*  Do some common intialisation  */
	SpecificInit();
	MainLoop();
	}

